<script lang="ts">
	import { matrixBots } from "../provider/MatrixBots";
	import { HostingType, type MatrixBotInterface } from "../types";
	import PriceLabel from "../ui/PriceLabel.svelte";
	import ServerNotPowerfulBadge from "../ui/ServerNotPowerfulBadge.svelte";
	import { isServerEnoughForComponent } from "../utils";
	import { entityStore } from '../utils/entityStore';

	export let selectedBots: Partial<MatrixBotInterface>[];

	let matrixBotsToUse = JSON.parse(JSON.stringify(matrixBots));

	$: if ($entityStore) {
		// reset this section
		if ($entityStore.hostingType !== HostingType.BYOS) {
			selectedBots = selectedBots.filter((bot) => {
				return isServerEnoughForComponent(bot, $entityStore);
			});
		}
	}
</script>

<div class="row">
	<div class="col-12 mb-3">
		<p>You can include various chat bots to make your life easier.</p>
	</div>
	<div class="col-md-12 mb-2">
		{#each matrixBotsToUse as bot, botIdx}
			{#if !bot.archived}
			{@const serverIsEnoughForComponent = isServerEnoughForComponent(bot, $entityStore)}
			{@const componentIsSelected = selectedBots.find((current) => current.id === bot.id)}
			<div
				class="d-flex flex-row mb-1 justify-content-between align-items-center"
			>
				<div class="d-flex align-items-center flex-grow-1">
					<span class="form-check form-switch d-inline-block align-self-start">
						<input
							id={"bot-" + bot.id}
							class="form-check-input"
							type="checkbox"
							disabled={!serverIsEnoughForComponent}
							bind:group={selectedBots}
							name="matrix-bot"
							value={bot}
						/>
					</span>

					<div class="d-flex flex-column flex-grow-1">
						<label for={"bot-" + bot.id} class="px-2">
							<span class="d-inline-block">{bot.name}</span>
							<br />
							<span class="text text-muted">{bot.description}</span>
						</label>
					</div>
				</div>
				<div class="d-flex flex-column flex-md-row">
					<a href={bot.help} target="_blank" rel="noreferrer">
						<span
							class="d-inline badge rounded-pill text-primary btn btn-outline-warning"
						>
							more details
						</span>
					</a>
					<div class="ms-2 mt-3 my-md-0 d-block d-lg-inline-block"><PriceLabel price={bot.price} /></div>
				</div>
			</div>

			{#if componentIsSelected && bot.additionalFields}
				<div class="mt-3">
					{#if bot.helpText}
						<p>
							{@html bot.helpText}
						</p>
					{/if}

					{#each bot.additionalFields as botAdditionalField}
						<label
							class="mb-1"
							for={"botAdditionalField-" + botAdditionalField.id}
						>
							{botAdditionalField.name} <span class="text-danger fs-4">*</span>
						</label>
						<input
							class="form-control mb-2"
							type="text"
							id={"botAdditionalField-" + botAdditionalField.id}
							name={"botAdditionalField-" + botAdditionalField.id}
							placeholder={botAdditionalField.placeholder}
							required={botAdditionalField.required}
							bind:value={botAdditionalField.value}
						/>

						{#if botAdditionalField.tooltip}
							<p class="text-muted mb-1">
								{@html botAdditionalField.tooltip}
							</p>
						{/if}
					{/each}
				</div>
			{/if}
			<ServerNotPowerfulBadge serverIsPowerful={serverIsEnoughForComponent} />

			{#if botIdx !== matrixBots.length - 1}
			<hr />
			{/if}

			{/if}
		{/each}
	</div>
</div>
